<?php
namespace app\user\model;

use think\Model;

class UserBuddy extends Model {
	const Friend = 1;
	const Apply = 0;
	const Wait = 2;
	
	protected $createTime = 'inputtime';			// 创建时间
	protected $updateTime = 'updatetime';			// 每次更新时间
	protected $autoWriteTimestamp = 'datetime';		// 开启自动写入时间戳字段
	
	/**
	 * 查找好友列表
	 * @param int $user
	 * @return array|string|\think\Model
	 */
	public function findUserBuddy($user, $status = UserBuddy::Friend){
		return $this->db()->alias("b")
		->field("u.id i, u.nickname n, u.praise p, u.robot r, last_login t")
		->join("gd_user u", "u.id = b.buddy_id", "LEFT")
		->where(['b.user_id'=>$user, 'b.status'=>$status])
        ->limit(10)
		->select();
	}
	
	/**
	 * 找到好友
	 * @param int $user
	 * @param int $buddy
	 * @return array|string|\think\Model
	 */
	public function getBuddy($user, $buddy){
		return $this->db()->where(['user_id'=>$user, 'buddy_id'=>$buddy])->find();
// 		return $this->db()->alias("b")
// 		->field("u.id, u.nickname, u.praise, u.robot")
// 		->join("gd_user u", "u.id = b.user_id", "LEFT")
// 		->where(['user_id'=>$user, 'buddy_id'=>$buddy])
// 		->find();
	}
	
	/**
	 * 好友列表数量
	 * @param int $user
	 * @return number|string
	 */
	public function getBuddyCount($user){
		return $this->db()->where(['user_id'=>$user, 'status'=>UserBuddy::Friend])->count();
	}
	
	public function remove($data){
		return $this->db()->delete($data);
	}
	
	public function addAndSave($data){
		$this->data = $data;
		return $this->allowField(true)->isUpdate((isset($data['id']) && $data['id'])?true:false)->save($data);
	}
	
}