$(document).ready(function(){
	
	//获取鼠标双击事件
	map.addEventListener("dblclick" ,function(e){
		var marker = new BMap.Marker();//自定义一个图像标注
		var point = new BMap.Point(e.point.lng, e.point.lat);
		marker.setPosition(point);
		map.addOverlay(marker);
		addClickHandler(marker);
		addRightMenu(marker);
	});

	//点解覆盖物事件
	function addClickHandler(marker){
		marker.addEventListener("click",function(e){
			var html = [];
			createHTML(html,marker.getPosition().lng, marker.getPosition().lat);
			var point = new BMap.Point(marker.getPosition().lng, marker.getPosition().lat);
			var infoWindow = new BMap.InfoWindow(html.join(""),{title:"添加商户信息",enableMessage:false,offset: new BMap.Size(0,-20)});  // 创建信息窗口对象 
			map.openInfoWindow(infoWindow,point); //开启信息窗口
		});
	}
	
	//添加右键菜单
	function addRightMenu(marker){
		var menu = new BMap.ContextMenu();
		var txtMenuItem = [{
			text:'删除', 
			callback:function(){
				map.closeInfoWindow(marker);
				map.removeOverlay(marker);
			}
		}];
		for(var i=0; i < txtMenuItem.length; i++){
			menu.addItem(new BMap.MenuItem(txtMenuItem[i].text, txtMenuItem[i].callback, 100));
		}
		marker.addContextMenu(menu);
		//menu.addEventListener("open", function(){alert(1);}, new BMap.Point(marker.getPosition().lng, marker.getPosition().lat), new BMap.Pixel(0,0));
		marker.addEventListener("rightclick",function(e){
			map.closeInfoWindow(marker);
		});
	}
	
	
	function createHTML(html,lng,lat){
		html.push('<form enctype="multipart/form-data" method="post" action="index.html?m=business&a=add">');
		html.push('<table border="0" cellpadding="1" cellspacing="1" >');
		html.push('  <tr>'); 
		html.push('      <td align="left" class="common">名 称：</td>');
		html.push('      <td colspan="2"><input type="text" maxlength="50" size="18" name="name"/></td>');
		html.push('	     <td valign="top"><span class="star">*</span></td>');
		html.push('<input type="hidden" name="lng" value="'+lng+'" />');
		html.push('<input type="hidden" name="lat" value="'+lat+'" />');
		html.push('  </tr>');
		html.push('  <tr>');
		html.push('      <td  align="left" class="common">电 话：</td>');
		html.push('      <td colspan="2"><input type="text" maxlength="30" size="18" name="phone"/></td>');
		html.push('	     <td valign="top"><span class="star">*</span></td>');
		html.push('  </tr>');
		html.push('  <tr>');
		html.push('      <td  align="left" class="common">图片：</td>');
		html.push('      <td  colspan="2"><input type="file" style="width:150px;" name="image"/></td>');
		html.push('	     <td valign="top"><span class="star">*</span></td>');
		html.push('  </tr>');
		html.push('  <tr>');
		html.push('      <td  align="left" class="common">地 址：</td>');
		html.push('      <td  colspan="2"><input type="text" maxlength="50" size="18" name="address"/></td>');
		html.push('	     <td valign="top"><span class="star">*</span></td>');
		html.push('  </tr>');
		html.push('  <tr>');
		html.push('      <td align="left" class="common">描 述：</td>');
		html.push('      <td colspan="2"><textarea rows="3" cols="20" name="remark"></textarea></td>');
		html.push('	     <td valign="top"></td>');
		html.push('  </tr>');
		html.push('  <tr>');
		html.push('	     <td  align="center" colspan="3">');
		html.push('          <input type="submit" name="btnOK" value="确定">&nbsp;&nbsp;');
		html.push('		     <input type="button" name="btnClear" id="temp" value="重填">');
		html.push('	     </td>');
		html.push('  </tr>');
		html.push('</table></form>');	

	}

	
});